<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglContainersAggregate.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_5e9011f35b9434939eeeb25c7dbf1304.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersAggregate.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersAggregate_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLCONTAINERSAGGREGATE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLCONTAINERSAGGREGATE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtilsOmpTools_8h.html">tiglUtilsOmpTools.h</a>&quot;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtilsMacros_8h.html">tiglUtilsMacros.h</a>&quot;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationAggregateSysMessage_8hpp.html">tiglCommunicationAggregateSysMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"> * TIGLContainersAggregate class</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> AlgData&gt;</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html">   66</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;{</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;   <span class="keyword">typedef</span> AlgData ALG_DATA_TYPE;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLCommunicationAggregateSysMessage.html">TIGLCommunicationAggregateSysMessage&lt;AlgData&gt;</a> <a class="code" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>()</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;   {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;      omp_init_lock(&amp;aggLock);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;   }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   ~<a class="code" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>()</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   {</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;      omp_destroy_lock(&amp;aggLock);</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="comment">// static info</span></div>
<div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">  105</a></span>&#160;<span class="comment"></span>   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">numVertices</a>;</div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">  107</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">numLocalVertices</a>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   <span class="comment">// runtime statistics/info</span></div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">  111</a></span>&#160;<span class="comment"></span>   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a>;</div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">  113</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">  115</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">  117</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">numLocalActiveNodes</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a38a14d8e84fbe0103c1c043d4485d958">  119</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a38a14d8e84fbe0103c1c043d4485d958">numTotalActiveNodes</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   <span class="comment">// algorithm specific information</span></div>
<div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">  123</a></span>&#160;<span class="comment"></span>   AlgData <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">  125</a></span>&#160;   AlgData <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00127"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">  127</a></span>&#160;   AlgData <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">  129</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="comment">// openMP lock for updating aggregate info</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   omp_lock_t aggLock;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="comment">    * public methods</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00150"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a04afa8cf6216839d4c877fe28e34ad53">  150</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#a04afa8cf6216839d4c877fe28e34ad53">localAggregateInit</a>(uint_fast32_t ssIndex, uint_fast32_t numLocActiveNodes)</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   {</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> = ssIndex;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      <span class="keywordtype">int</span> t = <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[t] = 0;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[t] = 0;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">numLocalActiveNodes</a>[t] = numLocActiveNodes;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;   }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> VERTEX_ITERATOR&gt;</div>
<div class="line"><a name="l00170"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#aca8c7367d645f65d1d2c7fbc96eb3096">  170</a></span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#aca8c7367d645f65d1d2c7fbc96eb3096">localAggregateUpdate</a>(VERTEX_ITERATOR vertexIt, uint_fast32_t currNumMessages)</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   {</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;      <span class="keywordtype">int</span> t = <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;      <span class="keywordflow">if</span> (vertexIt-&gt;isActive())</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;      {</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;         <span class="comment">//lock();</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;         ALG_DATA_TYPE newData = vertexIt-&gt;getAlgData();</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;         <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t] &lt; newData || <a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;         {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical (AGGREGATE_MAX)&quot;</span>)</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;               <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t] &lt; newData)</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;               {</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                  <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t] = newData;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="comment">//                      ALG_DATA_TYPE * p = &amp;minActiveAlgData[t];</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="comment">//                      OMP(&quot;omp flush (p)&quot;)</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;               }</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            }</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;         }</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;         <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t] &gt; newData || <a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;         {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical(AGGREGATE_MIN)&quot;</span>)</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            {</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;               <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t] &gt; newData)</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;               {</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                  <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t] = newData;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">//                      ALG_DATA_TYPE * p = &amp;minActiveAlgData[t];</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="comment">//                      OMP(&quot;omp flush (p)&quot;)</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;               }</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            }</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;         }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;         OMP(<span class="stringliteral">&quot;omp critical(AGGREGATE_SUM)&quot;</span>)</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;         {</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;               <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[t] += newData;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;               <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[t] = newData;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;         }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;      }</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;      <span class="comment">//lock();</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      OMP(<span class="stringliteral">&quot;omp atomic&quot;</span>)</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[t] += currNumMessages;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;      <span class="comment">//unlock();</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;      <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;      {</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;         <a class="code" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a> = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;      OMP(<span class="stringliteral">&quot;omp flush(isUpdated)&quot;</span>)</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;   }</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;}</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00228"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a0fe6f8be5e07c64170b6a92f057db61c">  228</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#a0fe6f8be5e07c64170b6a92f057db61c">externalAggregateUpdate</a>(<a class="code" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> * aggSysInfo)</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;{</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;   <span class="keywordtype">int</span> t = (<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;   ALG_DATA_TYPE newData = aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#a1b722b1881d267326cf306f23efc55f5">getMax</a>();</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t] &lt; newData)</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   {</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t] = newData;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;   }</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;   newData = aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#adc25a777bb27c33fd6e4608a1843acd1">getMin</a>();</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;   <span class="keywordflow">if</span> (<a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t] &gt; newData)</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;   {</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;      <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t] = newData;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;   }</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;   newData = aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#a5668215562c36ee5af964c0c67a90513">getSum</a>();</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[t] += newData;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;}</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00253"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a3ee8a15559012f6b8bb3df99887f4594">  253</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#a3ee8a15559012f6b8bb3df99887f4594">prepareAggregateSysMessage</a>(<a class="code" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> * aggSysInfo)</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;{</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;   <span class="keywordtype">int</span> t = <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;   aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#aa27fa8ae77696b961b244328471fcd5e">setMax</a>(<a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[t]);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;   aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#a01daf065f691f649fe43bad6cd37d10a">setMin</a>(<a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[t]);</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;   aggSysInfo-&gt;<a class="code" href="classTIGLCommunicationAggregateSysMessage.html#ae4f2508c081eb577bb63fc734ad6447f">setSum</a>(<a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[t]);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment">//      cout &lt;&lt; &quot;countSS &quot; &lt;&lt; countSS &lt;&lt; &quot;: max &quot;&lt;&lt; maxActiveAlgData[t] &lt;&lt; endl;</span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;}</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00269"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a2b7398a983604cf319ecc14b5dc43cee">  269</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#a2b7398a983604cf319ecc14b5dc43cee">incrementExternalMessagesCount</a>(uint_fast32_t currNumMessages)</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;{</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;   lock();</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY] += currNumMessages;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;   unlock();</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;}</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00282"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#af9b0510a2daf3d252622f75cc3a12b10">  282</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#af9b0510a2daf3d252622f75cc3a12b10">setNumLocalActiveNoes</a>(uint_fast32_t numActive)</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;{</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">numLocalActiveNodes</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY] = numActive;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;}</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00292"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a6be61ecacbdac8f97e134141fe89a64b">  292</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a6be61ecacbdac8f97e134141fe89a64b">getNumExternalMessages</a>()</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;{</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;}</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00302"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a69865b656cd9b474e149625492f89b3a">  302</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a69865b656cd9b474e149625492f89b3a">getPastNumExternalMessages</a>()</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;{</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[(<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;}</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00312"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a8a260b73f6eca28cc04fef12c7e3edac">  312</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a8a260b73f6eca28cc04fef12c7e3edac">getNumTotalMessages</a>()</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;{</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;}</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00322"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a3913c2be0d087f69892ee0d1b4e02c08">  322</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a3913c2be0d087f69892ee0d1b4e02c08">getPastNumTotalMessages</a>()</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;{</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[(<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;}</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00332"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a13da64d53762dc1e1e0900e28903c2cf">  332</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a13da64d53762dc1e1e0900e28903c2cf">getNumVertices</a>()</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;{</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">numVertices</a>;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;}</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00342"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#aa63f0a94c65a484525209b3b446a8280">  342</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#aa63f0a94c65a484525209b3b446a8280">setNumVertices</a>(uint_fast32_t num)</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;{</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">numVertices</a> = num;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;}</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00352"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a60a16ff13b899f8237994cac8b01908e">  352</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a60a16ff13b899f8237994cac8b01908e">getNumLocalVertices</a>()</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;{</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">numLocalVertices</a>;</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;}</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00362"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a87a3a907d1ccffd79eeb24b11ae9bfc4">  362</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersAggregate.html#a87a3a907d1ccffd79eeb24b11ae9bfc4">setNumLocalVertices</a>(uint_fast32_t num)</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;{</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;   <a class="code" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">numLocalVertices</a> = num;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;}</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div>
<div class="line"><a name="l00373"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a12614a74824ea634b4665bf6e0b6022d">  373</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersAggregate.html#a12614a74824ea634b4665bf6e0b6022d">getNumSS</a>()</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;{</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a>;</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;}</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00383"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a2563e0a0ac054729638cd9b55359df00">  383</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a2563e0a0ac054729638cd9b55359df00">getMaxActiveAlgData</a>()</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;{</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;}</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00393"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a4e308f42d847083bba45040eda5a9eeb">  393</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a4e308f42d847083bba45040eda5a9eeb">getPastMaxActiveAlgData</a>()</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;{</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[(<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;}</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00403"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a142af06cf094b1ae4dac2a8abfd55310">  403</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a142af06cf094b1ae4dac2a8abfd55310">getMinActiveAlgData</a>()</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;{</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;}</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00413"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a17eb0efe3b39b2ac61930fedc6cf7237">  413</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a17eb0efe3b39b2ac61930fedc6cf7237">getPastMinActiveAlgData</a>()</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;{</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[(<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;}</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00423"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a43df95a92f21ee9e2e2a1443629f5cfc">  423</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a43df95a92f21ee9e2e2a1443629f5cfc">getSumActiveAlgData</a>()</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;{</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;}</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00433"></a><span class="lineno"><a class="line" href="classTIGLContainersAggregate.html#a9c7d3314127c59ce3ed1c23378b6e57e">  433</a></span>&#160;<span class="keyword">inline</span> AlgData &amp; <a class="code" href="classTIGLContainersAggregate.html#a9c7d3314127c59ce3ed1c23378b6e57e">getPastSumActiveAlgData</a>()</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;{</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;   <span class="keywordflow">return</span> <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[(<a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a> - 1) % AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;}</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> lock()</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;{  omp_set_lock(&amp;aggLock);}</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> unlock()</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;{  omp_unset_lock(&amp;aggLock);}</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> lock()</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;{</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;}</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> unlock()</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;{</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;}</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;};</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCONTAINERSAGGREGATE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLContainersAggregate_html_adee5333a31d8f0199b059006b0b0a2c3"><div class="ttname"><a href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">TIGLContainersAggregate::minActiveAlgData</a></div><div class="ttdeci">AlgData minActiveAlgData[AGGREGATE_HISTORY]</div><div class="ttdoc">minimum value of algorithm data of all active vertices over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:125</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_ae4f2508c081eb577bb63fc734ad6447f"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#ae4f2508c081eb577bb63fc734ad6447f">TIGLCommunicationAggregateSysMessage::setSum</a></div><div class="ttdeci">void setSum(AlgData val)</div><div class="ttdoc">set the sum value field </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:100</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a3913c2be0d087f69892ee0d1b4e02c08"><div class="ttname"><a href="classTIGLContainersAggregate.html#a3913c2be0d087f69892ee0d1b4e02c08">TIGLContainersAggregate::getPastNumTotalMessages</a></div><div class="ttdeci">uint_fast32_t getPastNumTotalMessages()</div><div class="ttdoc">Returns the total number of output messages of the device in the previous superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:322</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a69865b656cd9b474e149625492f89b3a"><div class="ttname"><a href="classTIGLContainersAggregate.html#a69865b656cd9b474e149625492f89b3a">TIGLContainersAggregate::getPastNumExternalMessages</a></div><div class="ttdeci">uint_fast32_t getPastNumExternalMessages()</div><div class="ttdoc">Returns the number of external messages in the previous superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:302</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_adc25a777bb27c33fd6e4608a1843acd1"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#adc25a777bb27c33fd6e4608a1843acd1">TIGLCommunicationAggregateSysMessage::getMin</a></div><div class="ttdeci">AlgData getMin()</div><div class="ttdoc">get the min value field </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:120</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a634cea0f993b93549a4c8df631a8996a"><div class="ttname"><a href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">TIGLContainersAggregate::isUpdated</a></div><div class="ttdeci">bool isUpdated</div><div class="ttdoc">update flag </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:129</div></div>
<div class="ttc" id="tiglUtilsMacros_8h_html"><div class="ttname"><a href="tiglUtilsMacros_8h.html">tiglUtilsMacros.h</a></div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a5561ee95dd89b5f948275baf2069f383"><div class="ttname"><a href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">TIGLContainersAggregate::countSS</a></div><div class="ttdeci">uint_fast32_t countSS</div><div class="ttdoc">superstep counter </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:111</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a17eb0efe3b39b2ac61930fedc6cf7237"><div class="ttname"><a href="classTIGLContainersAggregate.html#a17eb0efe3b39b2ac61930fedc6cf7237">TIGLContainersAggregate::getPastMinActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastMinActiveAlgData()</div><div class="ttdoc">Returns the minimum value of the algorithm data of all active nodes for the previous superstep...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:413</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html"><div class="ttname"><a href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a></div><div class="ttdoc">Base class for aggregate information. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:66</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a0fe6f8be5e07c64170b6a92f057db61c"><div class="ttname"><a href="classTIGLContainersAggregate.html#a0fe6f8be5e07c64170b6a92f057db61c">TIGLContainersAggregate::externalAggregateUpdate</a></div><div class="ttdeci">void externalAggregateUpdate(AGG_SYS_MESSAGE_TYPE *aggSysInfo)</div><div class="ttdoc">Updates the aggregate information after receiving an update from other devices. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:228</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_acc02e42cdc6d4cf91525e563535c6ac2"><div class="ttname"><a href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">TIGLContainersAggregate::numTotalMessages</a></div><div class="ttdeci">uint_fast32_t numTotalMessages[AGGREGATE_HISTORY]</div><div class="ttdoc">total number of output messages over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:113</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a60a16ff13b899f8237994cac8b01908e"><div class="ttname"><a href="classTIGLContainersAggregate.html#a60a16ff13b899f8237994cac8b01908e">TIGLContainersAggregate::getNumLocalVertices</a></div><div class="ttdeci">uint_fast32_t getNumLocalVertices()</div><div class="ttdoc">Returns the number of local vertices. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:352</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a6e2cc4436a685cf860d668266212f42d"><div class="ttname"><a href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">TIGLContainersAggregate::sumActiveAlgData</a></div><div class="ttdeci">AlgData sumActiveAlgData[AGGREGATE_HISTORY]</div><div class="ttdoc">the sum of the values of algorithm data of all active vertices over a superstep history ...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:127</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_a5668215562c36ee5af964c0c67a90513"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#a5668215562c36ee5af964c0c67a90513">TIGLCommunicationAggregateSysMessage::getSum</a></div><div class="ttdeci">AlgData getSum()</div><div class="ttdoc">get the sum value field </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:130</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a13da64d53762dc1e1e0900e28903c2cf"><div class="ttname"><a href="classTIGLContainersAggregate.html#a13da64d53762dc1e1e0900e28903c2cf">TIGLContainersAggregate::getNumVertices</a></div><div class="ttdeci">uint_fast32_t getNumVertices()</div><div class="ttdoc">Returns the total number of vertices in the whole graph. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:332</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a04afa8cf6216839d4c877fe28e34ad53"><div class="ttname"><a href="classTIGLContainersAggregate.html#a04afa8cf6216839d4c877fe28e34ad53">TIGLContainersAggregate::localAggregateInit</a></div><div class="ttdeci">void localAggregateInit(uint_fast32_t ssIndex, uint_fast32_t numLocActiveNodes)</div><div class="ttdoc">Resets the aggregate parameters before the new superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:150</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_aca8c7367d645f65d1d2c7fbc96eb3096"><div class="ttname"><a href="classTIGLContainersAggregate.html#aca8c7367d645f65d1d2c7fbc96eb3096">TIGLContainersAggregate::localAggregateUpdate</a></div><div class="ttdeci">void localAggregateUpdate(VERTEX_ITERATOR vertexIt, uint_fast32_t currNumMessages)</div><div class="ttdoc">Updates the aggregate information after a single node execution during a superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:170</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a2563e0a0ac054729638cd9b55359df00"><div class="ttname"><a href="classTIGLContainersAggregate.html#a2563e0a0ac054729638cd9b55359df00">TIGLContainersAggregate::getMaxActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getMaxActiveAlgData()</div><div class="ttdoc">Returns the maximum value of the algorithm data of all active nodes for the current superstep...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:383</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a2b7398a983604cf319ecc14b5dc43cee"><div class="ttname"><a href="classTIGLContainersAggregate.html#a2b7398a983604cf319ecc14b5dc43cee">TIGLContainersAggregate::incrementExternalMessagesCount</a></div><div class="ttdeci">void incrementExternalMessagesCount(uint_fast32_t currNumMessages)</div><div class="ttdoc">Increments the number of external Messages after a single node compute in a superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:269</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a6be61ecacbdac8f97e134141fe89a64b"><div class="ttname"><a href="classTIGLContainersAggregate.html#a6be61ecacbdac8f97e134141fe89a64b">TIGLContainersAggregate::getNumExternalMessages</a></div><div class="ttdeci">uint_fast32_t getNumExternalMessages()</div><div class="ttdoc">Returns the number of external messages in the current superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:292</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a43df95a92f21ee9e2e2a1443629f5cfc"><div class="ttname"><a href="classTIGLContainersAggregate.html#a43df95a92f21ee9e2e2a1443629f5cfc">TIGLContainersAggregate::getSumActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getSumActiveAlgData()</div><div class="ttdoc">Returns the sum of the algorithm data of all active nodes for the current superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:423</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_aa63f0a94c65a484525209b3b446a8280"><div class="ttname"><a href="classTIGLContainersAggregate.html#aa63f0a94c65a484525209b3b446a8280">TIGLContainersAggregate::setNumVertices</a></div><div class="ttdeci">void setNumVertices(uint_fast32_t num)</div><div class="ttdoc">Sets the total number of vertices in the whole graph. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:342</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html">TIGLCommunicationAggregateSysMessage</a></div><div class="ttdoc">Base class for aggregate information messages. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:54</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a9c7d3314127c59ce3ed1c23378b6e57e"><div class="ttname"><a href="classTIGLContainersAggregate.html#a9c7d3314127c59ce3ed1c23378b6e57e">TIGLContainersAggregate::getPastSumActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastSumActiveAlgData()</div><div class="ttdoc">Returns the sum of the algorithm data of all active nodes for the previous superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:433</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a305621751cb671f32cfac297765b50bc"><div class="ttname"><a href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">TIGLContainersAggregate::numVertices</a></div><div class="ttdeci">uint_fast32_t numVertices</div><div class="ttdoc">total number of vertices in the graph </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:105</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a38a14d8e84fbe0103c1c043d4485d958"><div class="ttname"><a href="classTIGLContainersAggregate.html#a38a14d8e84fbe0103c1c043d4485d958">TIGLContainersAggregate::numTotalActiveNodes</a></div><div class="ttdeci">uint_fast32_t numTotalActiveNodes[AGGREGATE_HISTORY]</div><div class="ttdoc">total number of active nodes over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:119</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a36c75840693e07da4d59fe8269720fa9"><div class="ttname"><a href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">TIGLContainersAggregate::numLocalActiveNodes</a></div><div class="ttdeci">uint_fast32_t numLocalActiveNodes[AGGREGATE_HISTORY]</div><div class="ttdoc">number of local active nodes over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:117</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_a01daf065f691f649fe43bad6cd37d10a"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#a01daf065f691f649fe43bad6cd37d10a">TIGLCommunicationAggregateSysMessage::setMin</a></div><div class="ttdeci">void setMin(AlgData val)</div><div class="ttdoc">set the minimum value of the algData </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:90</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a8a260b73f6eca28cc04fef12c7e3edac"><div class="ttname"><a href="classTIGLContainersAggregate.html#a8a260b73f6eca28cc04fef12c7e3edac">TIGLContainersAggregate::getNumTotalMessages</a></div><div class="ttdeci">uint_fast32_t getNumTotalMessages()</div><div class="ttdoc">Returns the total number of output messages of the device in the current superstep. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:312</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_adbc8349ec3065a2dfccebce5527bec82"><div class="ttname"><a href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">TIGLContainersAggregate::numExternalMessages</a></div><div class="ttdeci">uint_fast32_t numExternalMessages[AGGREGATE_HISTORY]</div><div class="ttdoc">total number of external output messages over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:115</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a4e308f42d847083bba45040eda5a9eeb"><div class="ttname"><a href="classTIGLContainersAggregate.html#a4e308f42d847083bba45040eda5a9eeb">TIGLContainersAggregate::getPastMaxActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastMaxActiveAlgData()</div><div class="ttdoc">Returns the maximum value of the algorithm data of all active nodes for the previous superstep...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:393</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a3ee8a15559012f6b8bb3df99887f4594"><div class="ttname"><a href="classTIGLContainersAggregate.html#a3ee8a15559012f6b8bb3df99887f4594">TIGLContainersAggregate::prepareAggregateSysMessage</a></div><div class="ttdeci">void prepareAggregateSysMessage(AGG_SYS_MESSAGE_TYPE *aggSysInfo)</div><div class="ttdoc">Prepares the aggregate information system message (at the end of the superstep) </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:253</div></div>
<div class="ttc" id="tiglCommunicationAggregateSysMessage_8hpp_html"><div class="ttname"><a href="tiglCommunicationAggregateSysMessage_8hpp.html">tiglCommunicationAggregateSysMessage.hpp</a></div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_aa27fa8ae77696b961b244328471fcd5e"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#aa27fa8ae77696b961b244328471fcd5e">TIGLCommunicationAggregateSysMessage::setMax</a></div><div class="ttdeci">void setMax(AlgData val)</div><div class="ttdoc">set the maximum value </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:80</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a87a3a907d1ccffd79eeb24b11ae9bfc4"><div class="ttname"><a href="classTIGLContainersAggregate.html#a87a3a907d1ccffd79eeb24b11ae9bfc4">TIGLContainersAggregate::setNumLocalVertices</a></div><div class="ttdeci">void setNumLocalVertices(uint_fast32_t num)</div><div class="ttdoc">Sets the number of local vertices. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:362</div></div>
<div class="ttc" id="classTIGLCommunicationAggregateSysMessage_html_a1b722b1881d267326cf306f23efc55f5"><div class="ttname"><a href="classTIGLCommunicationAggregateSysMessage.html#a1b722b1881d267326cf306f23efc55f5">TIGLCommunicationAggregateSysMessage::getMax</a></div><div class="ttdeci">AlgData getMax()</div><div class="ttdoc">get the max value field </div><div class="ttdef"><b>Definition:</b> tiglCommunicationAggregateSysMessage.hpp:110</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_af9b0510a2daf3d252622f75cc3a12b10"><div class="ttname"><a href="classTIGLContainersAggregate.html#af9b0510a2daf3d252622f75cc3a12b10">TIGLContainersAggregate::setNumLocalActiveNoes</a></div><div class="ttdeci">void setNumLocalActiveNoes(uint_fast32_t numActive)</div><div class="ttdoc">set the number of local active nodes at the end of a superstep </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:282</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_adbea704396b2b82f8f9b260c86206e6e"><div class="ttname"><a href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">TIGLContainersAggregate::numLocalVertices</a></div><div class="ttdeci">uint_fast32_t numLocalVertices</div><div class="ttdoc">number of local vertices for this device </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:107</div></div>
<div class="ttc" id="tiglUtilsOmpTools_8h_html"><div class="ttname"><a href="tiglUtilsOmpTools_8h.html">tiglUtilsOmpTools.h</a></div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a142af06cf094b1ae4dac2a8abfd55310"><div class="ttname"><a href="classTIGLContainersAggregate.html#a142af06cf094b1ae4dac2a8abfd55310">TIGLContainersAggregate::getMinActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getMinActiveAlgData()</div><div class="ttdoc">Returns the minimum value of the algorithm data of all active nodes for the current superstep...</div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:403</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_a12614a74824ea634b4665bf6e0b6022d"><div class="ttname"><a href="classTIGLContainersAggregate.html#a12614a74824ea634b4665bf6e0b6022d">TIGLContainersAggregate::getNumSS</a></div><div class="ttdeci">uint_fast32_t getNumSS()</div><div class="ttdoc">Returns the superstep count. </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:373</div></div>
<div class="ttc" id="classTIGLContainersAggregate_html_ada6c83411d9eb54ddcba58b7db52c7ca"><div class="ttname"><a href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">TIGLContainersAggregate::maxActiveAlgData</a></div><div class="ttdeci">AlgData maxActiveAlgData[AGGREGATE_HISTORY]</div><div class="ttdoc">maximum value of algorithm data of all active vertices over a superstep history </div><div class="ttdef"><b>Definition:</b> tiglContainersAggregate.hpp:123</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
